package {
	import com.itechnica.svg.draw.IDrawable;	
	import com.itechnica.svg.draw.DrawingCommand;	
	
	import flash.display.Graphics;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	
	import com.itechnica.svg.PathToArray;import flash.utils.getTimer;		

	public class SVGDisplayInFlash extends MovieClip {
		
		private static const SVG_DATA_URL:String = "coloredtoucan.svg";
		private static const HOLDER_NAME:String = "holder";
		private static const MESSAGE_NAME:String = "msg";
		
		private var holderMc:MovieClip;
		private var messageTxt:TextField;

		public function SVGDisplayInFlash() {
			initInstance();
		}
		
		private function initInstance():void {
			// trace("SVGDisplayInFlash.initInstance()");
			initStageObjects();
			// testPathToArray();
			getSVGData(SVG_DATA_URL);
		}
		private function initStageObjects():void {
			holderMc = this[HOLDER_NAME] as MovieClip;
			messageTxt = this[MESSAGE_NAME] as TextField;
			// trace("SVGDisplayInFlash.initStageObjects()");
			// trace("\t", holderMc, messageTxt);
		}
		
		private function getSVGData(url:String):void {
			const loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, onSVGLoaded);
			loader.load(new URLRequest(url));
		}

		private var svg:XMLDocument = new XMLDocument();
		private var conv:PathToArray;
		private var paths:Array;
		private var nPathNodes:Number;
		
		
		private function onSVGLoaded(event:Event):void {
			const loader:URLLoader = event.target as URLLoader;
			const data:String = loader.data as String;
			
			messageTxt.text = "";
			
			svg.ignoreWhite = true;
			svg.parseXML(data);
			paths = svg.firstChild.firstChild.childNodes;
			nPathNodes = paths.length;
			
			var t:uint = getTimer();
			getShapes(0);
			trace((getTimer()-t));
		}
		
		private function getShapes(iPath:Number):void {
			var drawingCommands:Array = new Array();
			conv = new PathToArray(paths[iPath], drawingCommands);
		
			// draw the shapes in clips in holder movieclip
			// holder.createEmptyMovieClip("p"+iPath, iPath+1);
			
			const drawLayer:Sprite = new Sprite();
			holderMc.addChild(drawLayer);
			const drawTarget:Graphics = drawLayer.graphics;
			
			for (var i:Number=0; i<drawingCommands.length; i++) {
				var command:IDrawable = drawingCommands[i] as IDrawable;
				command.draw(drawTarget);
			}
			
			// repeat til all paths have been read
			if (++iPath < nPathNodes) getShapes(iPath);
		}

		protected function testPathToArray():void {
			const path:String = "<path fill='#ED1C24' d='M261.5,52.3c11.9,3.2-5.2,21,32.9,31.6C288.5,35.5,261.5,52.3,261.5,52.3z' />";
			const foo:XMLDocument = new XMLDocument(path);
			new PathToArray(foo.firstChild, []);
		}
		
	}

}
