package com.itechnica.svg.geom {
	import flash.geom.Point;	

	public class LineSVG {

		private var startPoint : Point;
		private var endPoint : Point;

		public function LineSVG(start : Point, end : Point) {
			initInstance(start, end);
		}

		private function initInstance(start : Point, end : Point) : void {
			startPoint = start;
			endPoint = end;
		}

		public function get start() : Point {
			return startPoint;
		}

		public function set start(value : Point) : void {
			startPoint = value;
		}

		public function get end() : Point {
			return endPoint;
		}

		public function set end(value : Point) : void {
			endPoint = value;
		}

		/**
		 * @description Returns the point of intersection between two lines
		 * @param LineSVG target line
		 * @returns Point point of intersection
		 */

		public function getLineIntersection(target : LineSVG) : Point {
			const currentDistanceX : Number = end.x - start.x;
			const targetDistanceX : Number = target.start.x - target.end.x;
		
			if (!(currentDistanceX || targetDistanceX)) { 
				return null;
			}
			const currentDistanceY : Number = end.y - start.y;
			const targetDistanceY : Number = target.start.y - target.end.y;
		   
			const currentTangent : Number = currentDistanceY / currentDistanceX;
			const targetTangent : Number = targetDistanceY / targetDistanceX;
		   
			if (!currentDistanceX) {
				return new Point(start.x, targetTangent * (start.x - target.end.x) + target.end.y);
			} else if (!targetDistanceX) {
				return new Point(target.end.x, currentTangent * (target.end.x - start.x) + start.y);
			}
			const intersectionX : Number = (-targetTangent * target.end.x + target.end.y + currentTangent * start.x - start.y) / (currentTangent - targetTangent);
			const intersectionY : Number = currentTangent * (intersectionX - start.x) + start.y;
			return new Point(intersectionX, intersectionY);
		}
	}
}




























